'use strict';

Object.defineProperty(exports, "__esModule", {
    value: true
});
exports.MqttApp = exports.WsApp = exports.HttpsApp = exports.App = exports.AModuler = undefined;

var _getPrototypeOf = require('babel-runtime/core-js/object/get-prototype-of');

var _getPrototypeOf2 = _interopRequireDefault(_getPrototypeOf);

var _possibleConstructorReturn2 = require('babel-runtime/helpers/possibleConstructorReturn');

var _possibleConstructorReturn3 = _interopRequireDefault(_possibleConstructorReturn2);

var _inherits2 = require('babel-runtime/helpers/inherits');

var _inherits3 = _interopRequireDefault(_inherits2);

var _regenerator = require('babel-runtime/regenerator');

var _regenerator2 = _interopRequireDefault(_regenerator);

var _asyncToGenerator2 = require('babel-runtime/helpers/asyncToGenerator');

var _asyncToGenerator3 = _interopRequireDefault(_asyncToGenerator2);

var _classCallCheck2 = require('babel-runtime/helpers/classCallCheck');

var _classCallCheck3 = _interopRequireDefault(_classCallCheck2);

var _createClass2 = require('babel-runtime/helpers/createClass');

var _createClass3 = _interopRequireDefault(_createClass2);

var _tool = require('gcl/com/coooders/common/tool');

var _tool2 = _interopRequireDefault(_tool);

var _http = require('http');

var _http2 = _interopRequireDefault(_http);

var _middler = require('gcl/com/coooders/bean/middler');

var _middler2 = _interopRequireDefault(_middler);

var _ni = require('gcl/com/coooders/db/ni');

var _ni2 = _interopRequireDefault(_ni);

var _https = require('https');

var _https2 = _interopRequireDefault(_https);

var _mosca = require('mosca');

var _mosca2 = _interopRequireDefault(_mosca);

var _socket = require('socket.io');

var _socket2 = _interopRequireDefault(_socket);

var _arraystream = require('gcl/com/coooders/collection/arraystream');

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

/**
 * VESH框架View层核心控件.
 * 处理器基类，定义init()，onrequest(request,response,session,[next]),onresponse(request,response,session,[next]),dispose()方法分别用于初始化，处理请求，对返回值进行过滤，销毁等一系列操作，Moduler之间按照责任链方式进行串联，任何返回真，或者对最后一个参数异步调用为真的方法都视作中止责任链，沿当前路径原路返回。
 */
var AModuler = exports.AModuler = function () {
    function AModuler(name) {
        (0, _classCallCheck3.default)(this, AModuler);
        pri(this, { name: name });
    }

    (0, _createClass3.default)(AModuler, [{
        key: 'init',
        value: function init() {
            return false;
        }
    }, {
        key: 'onrequest',
        value: function onrequest(req, rep, session) {
            return false;
        }
    }, {
        key: 'onresponse',
        value: function onresponse(req, rep, session) {
            return false;
        }
    }, {
        key: 'dispose',
        value: function dispose() {
            return false;
        }
    }, {
        key: 'Name',
        get: function get() {
            return pri(this).__.name;
        }
    }]);
    return AModuler;
}();
/**
 * VESH框架View层核心容器类
 */
var App = exports.App = function () {
    function App(config) {
        var pris = arguments.length > 1 && arguments[1] !== undefined ? arguments[1] : {};
        (0, _classCallCheck3.default)(this, App);

        if (!config) throw new Error('VESH:必须输入GCL.com.coooders.io.config.config对象实例');
        var that = this;

        var _pri = pri(this, _tool2.default.merge({
            config: config,
            middler: new _middler2.default.Middler(config),
            server: null,
            port: 80,
            errcall: function errcall(err, rep) {
                var _pri2 = pri(that),
                    _ = _pri2._,
                    __ = _pri2.__;

                console.log(err);
                __.log.error('VESH:' + (err.status || "") + err.message);
                //rep.setHeader('content-encoding', 'UTF-8');
                rep.writeHead(500, { 'Content-Type': 'text/plain' });
                rep.end(err.message, 'UTF-8');
            }
        }, pris)),
            _ = _pri._,
            __ = _pri.__;

        _tool2.default.merge(__, {
            log: __.middler.getObjectByAppName('VESH.view', 'com.coooders.Project.VESH.Logger'),
            ni: new _ni2.default.NiTemplateManager(__.middler, 'Ni'),
            modulers: __.middler.getObjectByAppName('VESH.view', 'com.coooders.Project.VESH.HttpModulers'),
            factory: __.middler.getObjectByAppName('VESH.view', 'com.coooders.Project.VESH.SessionDataManagerFactory')
        }, true);
        if (__.log) {
            //判断处理windows下无法监听标准错误的Bug
            if (_tool2.default.environment && _tool2.default.environment.os != 'windows') process.stderr.on('data', function (data) {
                return __.log.error("VESH:" + data);
            });
        } else throw new Error('VESH:必须定义VESH.view/com.coooders.Project.VESH.Logger对象');
        if (!__.factory) throw new Error('VESH:必须定义VESH.view/com.coooders.Project.VESH.SessionDataManagerFactory');
        if (__.modulers && __.modulers.length > 0) {
            //todo可能是异步的
            __.modulers.forEach(function (v) {
                return v.init();
            });
        } else throw new Error('VESH:必须定义VESH.view/com.coooders.Project.VESH.HttpModulers对象');
    }

    (0, _createClass3.default)(App, [{
        key: 'deal',
        value: function () {
            var _ref = (0, _asyncToGenerator3.default)( /*#__PURE__*/_regenerator2.default.mark(function _callee3(req, rep) {
                var _this = this;

                var _pri3, _, __, session, data;

                return _regenerator2.default.wrap(function _callee3$(_context3) {
                    while (1) {
                        switch (_context3.prev = _context3.next) {
                            case 0:
                                _pri3 = pri(this), _ = _pri3._, __ = _pri3.__;

                                __.log.info('HttpServer:' + _tool2.default.toJsonString(req.header) + " " + req.url);
                                _context3.prev = 2;

                                session = __.factory.getValue() || function () {
                                    throw new Error('VESH:必须定义VESH.view/com.coooders.Project.VESH.SessionDataManager对象');
                                }();

                                _context3.next = 6;
                                return session.init(__.config, __.middler, __.log, __.ni, req, rep);

                            case 6:
                                data = {};

                                data.modulers = 0;
                                //module处理
                                _context3.next = 10;
                                return _tool2.default.whileC(function () {
                                    return session.IsEnd ? null : __.modulers[data.modulers++];
                                }, function () {
                                    var _ref2 = (0, _asyncToGenerator3.default)( /*#__PURE__*/_regenerator2.default.mark(function _callee(v) {
                                        var ret;
                                        return _regenerator2.default.wrap(function _callee$(_context) {
                                            while (1) {
                                                switch (_context.prev = _context.next) {
                                                    case 0:
                                                        _context.prev = 0;

                                                        if (!v.onrequest) {
                                                            _context.next = 7;
                                                            break;
                                                        }

                                                        _context.next = 4;
                                                        return _tool2.default.callback2(function (call) {
                                                            return v.onrequest(req, rep, session, call);
                                                        });

                                                    case 4:
                                                        _context.t0 = _context.sent;
                                                        _context.next = 8;
                                                        break;

                                                    case 7:
                                                        _context.t0 = false;

                                                    case 8:
                                                        ret = _context.t0;

                                                        if (ret) {
                                                            session.end(200);
                                                        }
                                                        _context.next = 17;
                                                        break;

                                                    case 12:
                                                        _context.prev = 12;
                                                        _context.t1 = _context['catch'](0);

                                                        __.log.error('VESH:' + (v.Name ? v.Name + ': ' : ' ') + (_context.t1.status || '') + _context.t1.message);
                                                        console.log('VESH:' + (v.Name ? v.Name + ': ' : ' ') + (_context.t1.status || '') + _context.t1.message);
                                                        session.end(_context.t1.status || 500, _context.t1.message);

                                                    case 17:
                                                        return _context.abrupt('return', false);

                                                    case 18:
                                                    case 'end':
                                                        return _context.stop();
                                                }
                                            }
                                        }, _callee, _this, [[0, 12]]);
                                    }));

                                    return function (_x4) {
                                        return _ref2.apply(this, arguments);
                                    };
                                }(), true);

                            case 10:
                                _context3.next = 12;
                                return session.update();

                            case 12:
                                data.modulers--; //whileC默认会多判断一次
                                //console.log(data.modulers, __.modulers[data.modulers--]);
                                _context3.next = 15;
                                return _tool2.default.whileC(function () {
                                    return __.modulers[data.modulers-- - 1];
                                }, function () {
                                    var _ref3 = (0, _asyncToGenerator3.default)( /*#__PURE__*/_regenerator2.default.mark(function _callee2(v) {
                                        return _regenerator2.default.wrap(function _callee2$(_context2) {
                                            while (1) {
                                                switch (_context2.prev = _context2.next) {
                                                    case 0:
                                                        _context2.prev = 0;

                                                        if (!v.onresponse) {
                                                            _context2.next = 7;
                                                            break;
                                                        }

                                                        _context2.next = 4;
                                                        return _tool2.default.callback2(v.onresponse, v, req, rep, session);

                                                    case 4:
                                                        _context2.t0 = _context2.sent;
                                                        _context2.next = 8;
                                                        break;

                                                    case 7:
                                                        _context2.t0 = false;

                                                    case 8:
                                                        return _context2.abrupt('return', _context2.t0);

                                                    case 11:
                                                        _context2.prev = 11;
                                                        _context2.t1 = _context2['catch'](0);

                                                        __.log.error('VESH:' + (v.Name ? v.Name + ':' : '') + (_context2.t1.status || '') + _context2.t1.message);
                                                        console.log('VESH onresponse:' + (v.Name ? v.Name + ': ' : ' ') + (_context2.t1.status || '') + _context2.t1.message);
                                                        session.end(_context2.t1.status || 500, _context2.t1.message);
                                                        data.modulers = 0;

                                                    case 17:
                                                        return _context2.abrupt('return', false);

                                                    case 18:
                                                    case 'end':
                                                        return _context2.stop();
                                                }
                                            }
                                        }, _callee2, _this, [[0, 11]]);
                                    }));

                                    return function (_x5) {
                                        return _ref3.apply(this, arguments);
                                    };
                                }(), true);

                            case 15:
                                _context3.next = 17;
                                return session.flush();

                            case 17:
                                if (!_context3.sent) {
                                    _context3.next = 19;
                                    break;
                                }

                                rep.end();

                            case 19:
                                _context3.next = 24;
                                break;

                            case 21:
                                _context3.prev = 21;
                                _context3.t0 = _context3['catch'](2);

                                __.errcall(_context3.t0, rep);

                            case 24:
                                return _context3.abrupt('return', false);

                            case 25:
                            case 'end':
                                return _context3.stop();
                        }
                    }
                }, _callee3, this, [[2, 21]]);
            }));

            function deal(_x2, _x3) {
                return _ref.apply(this, arguments);
            }

            return deal;
        }()
    }, {
        key: 'deal1',
        value: function deal1(req, rep) {
            rep.end('ok');
        }
    }, {
        key: 'createServer',
        value: function createServer() {
            var _pri4 = pri(this),
                _ = _pri4._,
                __ = _pri4.__;

            var server = _http2.default.createServer(_.deal);
            //传递__ 因为deal中的this是server 不是 app;
            pri(server, __);
            return server;
        }
    }, {
        key: 'start',
        value: function start() {
            var port = arguments.length > 0 && arguments[0] !== undefined ? arguments[0] : 80;

            var _pri5 = pri(this),
                _ = _pri5._,
                __ = _pri5.__;

            if (__.server) {
                throw new Error('服务已经启动于' + __.port + '端口，请关闭后重新启动');
            } else {
                __.port = port;
                // 创建服务器
                __.server = _.createServer().listen(__.port);
                __.server.on('timeout', function () {
                    return __.log.info('HttpServer:连接超时');
                });
                __.server.on('connection', function () {
                    return __.log.info('HttpServer:发生新的连接');
                });
                __.server.on('clientError', function (err) {
                    return __.log.error('HttpServer:发生客户端错误' + err.stack);
                });
                process.on('SIGTERM', function () {
                    console.log("Received SIGTERM. Exiting.");
                    __.server.close(function () {
                        _.dispose();
                        process.exit(0);
                    });
                });
            }
        }
    }, {
        key: 'stop',
        value: function stop() {
            var _pri6 = pri(this),
                _ = _pri6._,
                __ = _pri6.__;

            if (__.server) {
                __.server.close();
                __.server.removeAllListeners();
                __.server = null;
            }
        }
    }, {
        key: 'dispose',
        value: function dispose() {
            var _pri7 = pri(this),
                _ = _pri7._,
                __ = _pri7.__;

            __.middler.setObjectByAppName('VESH.view', 'com.coooders.Project.VESH.Logger', __.log);
            __.modulers.forEach(function (v) {
                if (v.dispose) _tool2.default.tryC(function () {
                    return v.dispose();
                });
            });
        }
    }]);
    return App;
}();

/**
 * Https
 * @param {配置文件} config 
 * @param {秘钥} key 
 * @param {加密文件} cert 
 */
var HttpsApp = exports.HttpsApp = function (_App) {
    (0, _inherits3.default)(HttpsApp, _App);

    function HttpsApp(config) {
        var key = arguments.length > 1 && arguments[1] !== undefined ? arguments[1] : null;
        var cert = arguments.length > 2 && arguments[2] !== undefined ? arguments[2] : null;
        (0, _classCallCheck3.default)(this, HttpsApp);

        var _this2 = (0, _possibleConstructorReturn3.default)(this, (HttpsApp.__proto__ || (0, _getPrototypeOf2.default)(HttpsApp)).call(this, config));

        _this2.key = key;
        _this2.cert = cert;
        if (!(_tool2.default.isValid(key) && _tool2.default.isValid(cert))) throw new Error('请输入key,cert文件作为第二第三个参数');
        return _this2;
    }

    (0, _createClass3.default)(HttpsApp, [{
        key: 'createServer',
        value: function createServer() {
            var _pri8 = pri(this),
                _ = _pri8._,
                __ = _pri8.__;

            var server = _https2.default.createServer({ key: this.key, cert: this.cert }, _.deal);
            //传递__ 因为deal中的this是server 不是 app;
            pri(server, __);
            return server;
        }
    }]);
    return HttpsApp;
}(App);
//todo wss

/**
 * github: https://github.com/LearnBoost/socket.io
 * @param {配置文件} config 
 * @param {秘钥} key 
 * @param {加密文件} cert 
 */
var WsApp = exports.WsApp = function (_App2) {
    (0, _inherits3.default)(WsApp, _App2);

    function WsApp(config) {
        var key = arguments.length > 1 && arguments[1] !== undefined ? arguments[1] : null;
        var cert = arguments.length > 2 && arguments[2] !== undefined ? arguments[2] : null;
        (0, _classCallCheck3.default)(this, WsApp);
        return (0, _possibleConstructorReturn3.default)(this, (WsApp.__proto__ || (0, _getPrototypeOf2.default)(WsApp)).call(this, config, { port: 11211 }));
    }

    (0, _createClass3.default)(WsApp, [{
        key: 'createServer',
        value: function createServer() {
            var _pri9 = pri(this),
                _ = _pri9._,
                __ = _pri9.__;

            var server = _socket2.default.createServer();
            //传递__ 因为deal中的this是server 不是 app;
            pri(server, __);
            return server;
        }
    }]);
    return WsApp;
}(App);

/**
 * Mqtt
 * https://blog.csdn.net/ziyue13/article/details/121032362
 * @param {配置文件} config 
 * @param {秘钥} key 
 * @param {加密文件} cert 
 */
var MqttApp = exports.MqttApp = function (_App3) {
    (0, _inherits3.default)(MqttApp, _App3);

    function MqttApp(config) {
        var sendkey = arguments.length > 1 && arguments[1] !== undefined ? arguments[1] : "!@#$";
        (0, _classCallCheck3.default)(this, MqttApp);
        return (0, _possibleConstructorReturn3.default)(this, (MqttApp.__proto__ || (0, _getPrototypeOf2.default)(MqttApp)).call(this, config, {
            port: 1883,
            sendkey: sendkey,
            ascoltatore: {
                type: 'mongo',
                url: '', //'mongodb://localhost:27017/mqtt',
                pubsubCollection: 'ascoltatori',
                mongo: {}
            } }));
    }

    (0, _createClass3.default)(MqttApp, [{
        key: 'createServer',
        value: function createServer(conf) {
            var _pri10 = pri(this),
                _ = _pri10._,
                __ = _pri10.__;

            var server = _mosca2.default.createServer(_tool2.default.merge({
                port: __.port,
                ascoltatore: __.ascoltatore
            }, conf));
            //传递__ 因为deal中的this是server 不是 app;
            pri(server, __);
            return server;
        }
    }, {
        key: 'start',
        value: function start() {
            var port = arguments.length > 0 && arguments[0] !== undefined ? arguments[0] : 1883;
            var dburl = arguments[1];

            var _pri11 = pri(this),
                _ = _pri11._,
                __ = _pri11.__;

            if (__.server) {
                throw new Error('服务已经启动于' + __.port + '端口，请关闭后重新启动');
            } else {
                __.port = port;
                if (!dburl) throw new Error('请输入Mongo数据库链接地址!');
                // 创建服务器
                __.server = _.createServer({ port: port, ascoltatore: { url: dburl } });
                __.server.on('timeout', function () {
                    return __.log.info('MqttApp:连接超时');
                });
                __.server.on('clientConnected', function () {
                    return __.log.info('MqttApp:发生新的连接');
                });
                __.server.on('ready', function () {
                    return __.log.info('MqttApp:服务上线');
                });
                __.server.on('published', function (packet, client) {
                    __.log.info('MqttApp:收到新消息', packet, client.id);
                    try {
                        var form = _tool2.default.json(packet.payload || '{}');
                        //_topic和_sendkey成为服务唯一秘钥
                        if (form._topic && __.sendkey.eq(form._sendkey)) {
                            //这里直接转发mqtt内容
                            form._topic.split(';').map(function (v) {
                                __.server.publish({ topic: v, payload: _tool2.default.toJsonString(form.data || {}) });
                            });
                            return;
                        }
                        var req = {
                            headers: {
                                "content-type": "content-type",
                                host: "127.0.0.1", port: port,
                                protocol: 'mqtt://',
                                'accept-encoding-vesh': 'mqtt'
                            },
                            topic: packet.topic,
                            url: form._url || '/',
                            method: 'POST',
                            form: form,
                            querystring: {}
                        };
                        var rep = new _arraystream.ArrayStream();
                        rep.topic = packet.topic;
                        rep.statusCode = 200;
                        rep.headers = { "content-type": "application/json" };
                        rep.setHeader = function (k, v) {
                            rep.headers[k] = v;
                        };
                        rep.end = function (sb) {
                            if (rep.IsEnd) return;
                            rep.IsEnd = true;
                            rep.topic && rep.topic.split(';').map(function (v) {
                                return __.server.publish({ topic: v, payload: sb || Buffer.from(rep.toArray()).toString() });
                            });
                        };
                        _.deal(req, rep);
                    } catch (e) {
                        __.server.publish({ topic: "client.error", payload: _tool2.default.toJsonString({
                                id: client.id,
                                error: e.stack
                            }) });
                    }
                    return;
                });
                __.server.on('clientError', function (err) {
                    return __.log.error('MqttApp:发生客户端错误' + err.stack);
                });
                process.on('SIGTERM', function () {
                    console.log("Received SIGTERM. Exiting.");
                    __.server.close(function () {
                        _.dispose();
                        process.exit(0);
                    });
                });
            }
        }
    }, {
        key: 'stop',
        value: function stop() {
            var _pri12 = pri(this),
                _ = _pri12._,
                __ = _pri12.__;

            if (__.server) {
                __.server.close && __.server.close();
                __.server.removeAllListeners && __.server.removeAllListeners();
                __.server = null;
            }
        }
    }, {
        key: 'deal',
        value: function () {
            var _ref4 = (0, _asyncToGenerator3.default)( /*#__PURE__*/_regenerator2.default.mark(function _callee6(req, rep) {
                var _this5 = this;

                var _pri13, _, __, session, data;

                return _regenerator2.default.wrap(function _callee6$(_context6) {
                    while (1) {
                        switch (_context6.prev = _context6.next) {
                            case 0:
                                _pri13 = pri(this), _ = _pri13._, __ = _pri13.__;

                                __.log.info('MqttApp:' + _tool2.default.toJsonString(req.header) + " " + req.url);
                                _context6.prev = 2;

                                session = __.factory.getValue() || function () {
                                    throw new Error('VESH:必须定义VESH.view/com.coooders.Project.VESH.SessionDataManager对象');
                                }();

                                _context6.next = 6;
                                return session.init(__.config, __.middler, __.log, __.ni, req, rep);

                            case 6:
                                session.topic = req.topic;
                                data = {};

                                data.modulers = 0;
                                //module处理
                                _context6.next = 11;
                                return _tool2.default.whileC(function () {
                                    return session.IsEnd ? null : __.modulers[data.modulers++];
                                }, function () {
                                    var _ref5 = (0, _asyncToGenerator3.default)( /*#__PURE__*/_regenerator2.default.mark(function _callee4(v) {
                                        var ret;
                                        return _regenerator2.default.wrap(function _callee4$(_context4) {
                                            while (1) {
                                                switch (_context4.prev = _context4.next) {
                                                    case 0:
                                                        _context4.prev = 0;

                                                        if (!{
                                                            FormModuler: 1,
                                                            FilesModuler: 1
                                                        }[v.Name]) {
                                                            _context4.next = 3;
                                                            break;
                                                        }

                                                        return _context4.abrupt('return', false);

                                                    case 3:
                                                        if (!v.onrequest) {
                                                            _context4.next = 9;
                                                            break;
                                                        }

                                                        _context4.next = 6;
                                                        return _tool2.default.callback2(function (call) {
                                                            return v.onrequest(req, rep, session, call);
                                                        });

                                                    case 6:
                                                        _context4.t0 = _context4.sent;
                                                        _context4.next = 10;
                                                        break;

                                                    case 9:
                                                        _context4.t0 = false;

                                                    case 10:
                                                        ret = _context4.t0;

                                                        if (ret) {
                                                            session.end(200);
                                                        }
                                                        _context4.next = 19;
                                                        break;

                                                    case 14:
                                                        _context4.prev = 14;
                                                        _context4.t1 = _context4['catch'](0);

                                                        __.log.error('VESH:' + (v.Name ? v.Name + ': ' : ' ') + (_context4.t1.status || '') + _context4.t1.message);
                                                        console.log('VESH:' + (v.Name ? v.Name + ': ' : ' ') + (_context4.t1.status || '') + _context4.t1.message);
                                                        session.end(_context4.t1.status || 500, _context4.t1.message);

                                                    case 19:
                                                        return _context4.abrupt('return', false);

                                                    case 20:
                                                    case 'end':
                                                        return _context4.stop();
                                                }
                                            }
                                        }, _callee4, _this5, [[0, 14]]);
                                    }));

                                    return function (_x15) {
                                        return _ref5.apply(this, arguments);
                                    };
                                }(), true);

                            case 11:
                                _context6.next = 13;
                                return session.update();

                            case 13:
                                data.modulers--; //whileC默认会多判断一次
                                //console.log(data.modulers, __.modulers[data.modulers--]);
                                _context6.next = 16;
                                return _tool2.default.whileC(function () {
                                    return __.modulers[data.modulers-- - 1];
                                }, function () {
                                    var _ref6 = (0, _asyncToGenerator3.default)( /*#__PURE__*/_regenerator2.default.mark(function _callee5(v) {
                                        return _regenerator2.default.wrap(function _callee5$(_context5) {
                                            while (1) {
                                                switch (_context5.prev = _context5.next) {
                                                    case 0:
                                                        _context5.prev = 0;

                                                        if (!{
                                                            FormModuler: 1,
                                                            FilesModuler: 1
                                                        }[v.Name]) {
                                                            _context5.next = 3;
                                                            break;
                                                        }

                                                        return _context5.abrupt('return', false);

                                                    case 3:
                                                        if (!v.onresponse) {
                                                            _context5.next = 9;
                                                            break;
                                                        }

                                                        _context5.next = 6;
                                                        return _tool2.default.callback2(v.onresponse, v, req, rep, session);

                                                    case 6:
                                                        _context5.t0 = _context5.sent;
                                                        _context5.next = 10;
                                                        break;

                                                    case 9:
                                                        _context5.t0 = false;

                                                    case 10:
                                                        return _context5.abrupt('return', _context5.t0);

                                                    case 13:
                                                        _context5.prev = 13;
                                                        _context5.t1 = _context5['catch'](0);

                                                        __.log.error('VESH:' + (v.Name ? v.Name + ':' : '') + (_context5.t1.status || '') + _context5.t1.message);
                                                        console.log('VESH onresponse:' + (v.Name ? v.Name + ': ' : ' ') + (_context5.t1.status || '') + _context5.t1.message);
                                                        session.end(_context5.t1.status || 500, _context5.t1.message);
                                                        data.modulers = 0;

                                                    case 19:
                                                        return _context5.abrupt('return', false);

                                                    case 20:
                                                    case 'end':
                                                        return _context5.stop();
                                                }
                                            }
                                        }, _callee5, _this5, [[0, 13]]);
                                    }));

                                    return function (_x16) {
                                        return _ref6.apply(this, arguments);
                                    };
                                }(), true);

                            case 16:
                                rep.topic = session.topic;
                                _context6.next = 19;
                                return session.flush();

                            case 19:
                                if (!_context6.sent) {
                                    _context6.next = 21;
                                    break;
                                }

                                rep.end();

                            case 21:
                                _context6.next = 26;
                                break;

                            case 23:
                                _context6.prev = 23;
                                _context6.t0 = _context6['catch'](2);

                                __.errcall(_context6.t0, rep);

                            case 26:
                                return _context6.abrupt('return', false);

                            case 27:
                            case 'end':
                                return _context6.stop();
                        }
                    }
                }, _callee6, this, [[2, 23]]);
            }));

            function deal(_x13, _x14) {
                return _ref4.apply(this, arguments);
            }

            return deal;
        }()
    }]);
    return MqttApp;
}(App);

exports.default = { AModuler: AModuler, App: App, HttpsApp: HttpsApp, MqttApp: MqttApp };

var ___ = {};
var pri = _tool2.default.pris();
//# sourceMappingURL=app.js.map